diff -uNrp a/configure.ac b/configure.ac
--- a/configure.ac	2013-08-25 14:40:14.000000000 +0100
+++ b/configure.ac	2013-08-25 16:50:30.000000000 +0100
@@ -82,6 +82,22 @@ else
   SYSTEMD=
 fi
 
+# IBus support
+IBUS_REQUIRED_VERSION=1.4.2
+
+#AC_ARG_ENABLE(ibus,
+#        AS_HELP_STRING([--disable-ibus],
+#                       [Disable IBus support]),
+#        enable_ibus=$enableval,
+#        enable_ibus=yes)
+enable_ibus=yes
+#if test "x$enable_ibus" = "xyes" ; then
+IBUS_MODULE="ibus-1.0 >= $IBUS_REQUIRED_VERSION"
+AC_DEFINE(HAVE_IBUS, 1, [Defined if IBus support is enabled])
+#else
+#        IBUS_MODULE=
+#fi
+
 dnl ==============================================
 dnl Check that we meet the  dependencies
 dnl ==============================================
@@ -119,9 +135,10 @@ PKG_CHECK_MODULES(NETWORK_PANEL, $COMMON
 PKG_CHECK_MODULES(POWER_PANEL, $COMMON_MODULES upower-glib >= 0.9.1
                   cinnamon-settings-daemon >= $CSD_REQUIRED_VERSION)
 PKG_CHECK_MODULES(COLOR_PANEL, $COMMON_MODULES colord >= 0.1.8)
-PKG_CHECK_MODULES(REGION_PANEL, $COMMON_MODULES libgnomekbd >= 2.91.91
+PKG_CHECK_MODULES(REGION_PANEL, $COMMON_MODULES
                   polkit-gobject-1 >= $POLKIT_REQUIRED_VERSION
-                  libxklavier >= 5.1 libgnomekbdui >= 2.91.91)
+                  cinnamon-desktop >= $CINNAMON_DESKTOP_REQUIRED_VERSION
+                  $IBUS_MODULE)
 PKG_CHECK_MODULES(SCREEN_PANEL, $COMMON_MODULES)
 PKG_CHECK_MODULES(SOUND_PANEL, $COMMON_MODULES libxml-2.0
                   libcanberra-gtk3 >= $CANBERRA_REQUIRED_VERSION
diff -uNrp a/panels/region/cc-region-panel.c b/panels/region/cc-region-panel.c
--- a/panels/region/cc-region-panel.c	2013-08-25 14:40:14.000000000 +0100
+++ b/panels/region/cc-region-panel.c	2013-09-21 13:24:15.329949897 +0100
@@ -18,17 +18,18 @@
  * Author: Sergey Udaltsov <svu@gnome.org>
  *
  */
-#include "config.h"
+
 #include "cc-region-panel.h"
+#include <config.h>
 #include <gtk/gtk.h>
 #include <glib/gi18n-lib.h>
 
-#include "cinnamon-region-panel-xkb.h"
+#include "cinnamon-region-panel-input.h"
 #include "cinnamon-region-panel-lang.h"
 #include "cinnamon-region-panel-formats.h"
 #include "cinnamon-region-panel-system.h"
 
-G_DEFINE_DYNAMIC_TYPE (CcRegionPanel, cc_region_panel, CC_TYPE_PANEL)
+CC_PANEL_REGISTER (CcRegionPanel, cc_region_panel)
 
 #define REGION_PANEL_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), CC_TYPE_REGION_PANEL, CcRegionPanelPrivate))
 
@@ -48,14 +49,6 @@ enum {
 	SYSTEM_PAGE
 };
 
-
-static gboolean
-languages_link_cb (GtkButton *button, gpointer user_data)
-{
-    g_spawn_command_line_async ("gnome-language-selector", NULL);
-    return TRUE;
-}
-
 static void
 cc_region_panel_set_page (CcRegionPanel *panel,
 			  const char    *page)
@@ -116,13 +109,22 @@ cc_region_panel_finalize (GObject * obje
 	G_OBJECT_CLASS (cc_region_panel_parent_class)->finalize (object);
 }
 
+static const char *
+cc_region_panel_get_help_uri (CcPanel *panel)
+{
+  return "help:gnome-help/prefs-language";
+}
+
 static void
 cc_region_panel_class_init (CcRegionPanelClass * klass)
 {
 	GObjectClass *object_class = G_OBJECT_CLASS (klass);
+	CcPanelClass * panel_class = CC_PANEL_CLASS (klass);
 
 	g_type_class_add_private (klass, sizeof (CcRegionPanelPrivate));
 
+	panel_class->get_help_uri = cc_region_panel_get_help_uri;
+
 	object_class->set_property = cc_region_panel_set_property;
 	object_class->finalize = cc_region_panel_finalize;
 
@@ -130,22 +132,14 @@ cc_region_panel_class_init (CcRegionPane
 }
 
 static void
-cc_region_panel_class_finalize (CcRegionPanelClass * klass)
-{
-}
-
-static void
 cc_region_panel_init (CcRegionPanel * self)
 {
 	CcRegionPanelPrivate *priv;
 	GtkWidget *prefs_widget;
-	const char *desktop;
 	GError *error = NULL;
 
 	priv = self->priv = REGION_PANEL_PRIVATE (self);
 
-	desktop = g_getenv ("XDG_CURRENT_DESKTOP");
-
 	priv->builder = gtk_builder_new ();
     gtk_builder_set_translation_domain (priv->builder, GETTEXT_PACKAGE);
 	gtk_builder_add_from_file (priv->builder,
@@ -157,29 +151,16 @@ cc_region_panel_init (CcRegionPanel * se
 		return;
 	}
 
-    prefs_widget = (GtkWidget *) gtk_builder_get_object (priv->builder,
-                                                         "region_notebook");
-
+	prefs_widget = (GtkWidget *) gtk_builder_get_object (priv->builder,
+							     "region_notebook");
 	gtk_widget_set_size_request (GTK_WIDGET (prefs_widget), -1, 400);
 
 	gtk_widget_reparent (prefs_widget, GTK_WIDGET (self));
 
-    setup_xkb_tabs (priv->builder);
-
-    setup_language (priv->builder);
-    setup_formats (priv->builder);
-    setup_system (priv->builder);
-
-        /* set screen link */
-
-    GtkWidget *widget = GTK_WIDGET (gtk_builder_get_object (self->priv->builder,
-                                                            "get_languages_button"));
-
-    gtk_button_set_label (GTK_BUTTON (widget), _("Get more languages..."));
-
-    g_signal_connect (widget, "clicked",
-                      G_CALLBACK (languages_link_cb),
-                      self);
+        setup_input_tabs (priv->builder, self);
+	setup_language (priv->builder);
+	setup_formats (priv->builder);
+	setup_system (priv->builder);
 }
 
 void
@@ -187,6 +168,7 @@ cc_region_panel_register (GIOModule * mo
 {
     bindtextdomain (GETTEXT_PACKAGE, "/usr/share/cinnamon/locale");
     bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
+
 	cc_region_panel_register_type (G_TYPE_MODULE (module));
 	g_io_extension_point_implement (CC_SHELL_PANEL_EXTENSION_POINT,
 					CC_TYPE_REGION_PANEL,
diff -uNrp a/panels/region/cinnamon-region-panel-formats.h b/panels/region/cinnamon-region-panel-formats.h
--- a/panels/region/cinnamon-region-panel-formats.h	2013-08-25 14:40:14.000000000 +0100
+++ b/panels/region/cinnamon-region-panel-formats.h	2013-09-21 13:24:15.332949789 +0100
@@ -19,8 +19,8 @@
  * 02110-1335, USA.
  */
 
-#ifndef __GNOME_REGION_PANEL_FORMATS_H
-#define __GNOME_REGION_PANEL_FORMATS_H
+#ifndef __CINNAMON_REGION_PANEL_FORMATS_H
+#define __CINNAMON_REGION_PANEL_FORMATS_H
 
 #include <gtk/gtk.h>
 
